function checkSiteName(siteName) {
    var regex = /^[A-Za-z0-9_\-\.\*]+$/;
    return regex.test(siteName);
}

function listContainsSite(site) {
    var siteList = document.getElementById("sitelist");
    var numRows = siteList.getRowCount();
    for(i = 0; i < numRows; i++) {
        if(siteList.getItemAtIndex(i).label == site)
            return true;
    }
    return false;
}

function addSite() {
    var textbox = document.getElementById("siteTextbox");
    var siteName = textbox.value;

    if(siteName.length == 0)
        return false;

    if(! checkSiteName(siteName)) {
        var msg = flashblockBundle.getString("invalidCharsInSiteName");
        alert(msg);
        return;
    }

    var siteList = document.getElementById("sitelist");
    if(! listContainsSite(siteName))
        siteList.appendItem(siteName, "");
    textbox.value = "";
    siteInput(textbox);
	textbox.focus();
}

function removeSite() {
    var siteList = document.getElementById("sitelist");
    var index = siteList.selectedIndex;
    if(index != -1) {
        siteList.removeItemAt(index);
    }
}

function removeAllSites() {
    var siteList = document.getElementById("sitelist");
    var msg = flashblockBundle.getString("confirmClearWhitelist");

    if(confirm(msg)) {
        while(siteList.getRowCount() > 0)
            siteList.removeItemAt(0);
    }
}

function doOK() {
    var siteList = document.getElementById("sitelist");
    var numRows = siteList.getRowCount();
    var prefStr = "";
    for(i = 0; i < numRows; i++) {
        if(i != 0) prefStr += ",";
        prefStr += siteList.getItemAtIndex(i).label;
    }
    setWhitelistPref(prefStr);

	setEnabled(document.getElementById("enableCheckbox").checked);

    window.close();
}

function onLoad() {
	flashblockBundle = document.getElementById("bundle_flashblock");
	document.getElementById("enableCheckbox").checked = isEnabled();
	loadWhitelist();
}

function loadWhitelist() {
	var prefStr = getWhitelistPref();

	var siteList = document.getElementById("sitelist");
	while(siteList.getRowCount() > 0)
		siteList.removeItemAt(0);

	if(prefStr) {
		var array = prefStr.split(",");
		for (i = 0; i < array.length; i++) {
			siteList.appendItem(array[i]);
		}
	}
}

function doCancel() {
    window.close();
}

function siteInput(siteField) {
	document.getElementById("btnAdd").disabled = !siteField.value;
}

function siteSelected(siteList) {
	document.getElementById("btnRemove").disabled = (siteList.selectedIndex == -1);
}

var flashblockBundle;
